# -*- coding: utf-8 -*-
import xbmcplugin, xbmcgui
try:
	from urllib import urlopen
except ImportError:
	from urllib.request import urlopen
try:
	from urllib import urlencode
except ImportError:
	from urllib.parse import urlencode
try:
	from urlparse import urlparse, parse_qs, urlunparse
except ImportError:
	from urllib.parse import urlparse, parse_qs, urlunparse
from xml.dom.minidom import parseString
import re

def httpget(url):
	try:
		return urlopen(url).read().decode('utf-8')
	except:
		print url
		print 'captured'
		return False

def item(title, url, isFolder = True):
	listitem = xbmcgui.ListItem(title)
	xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urlencode({'url': url}), listitem, isFolder)

def play(title, url):
	listitem = xbmcgui.ListItem(title)
	xbmc.Player().play(url, listitem)

handle = int(sys.argv[1])
if sys.argv[2] == '':
	item('exodiver', 'https://github.com/exodiver/IPTV/tree/master/')
	item('freearhey', 'https://github.com/freearhey/IPTV/tree/master/channels')
	#url = 'https://github.com/exodiver/IPTV/tree/master/'
	xbmcplugin.endOfDirectory(handle)
else:
	url = parse_qs(urlparse(sys.argv[2]).query)['url'][0]
	o = urlparse(url)
	p = o.path.split('/')
	if o.netloc == 'github.com':
		if p[3] == 'blob':
			del p[3]
			url = urlunparse((o.scheme, 'raw.githubusercontent.com', '/'.join(p), o.params, o.query, o.fragment))
			content = httpget(url)
			for l in content.split('\n'):
				l = l.strip()
				if not l:
					continue
				if l[0] == '#':
					title = l.split(',')[-1].strip()
				else:
					item(title, l, False)
		else:
			content = httpget(url)
			if content == False:
				xbmcgui.Dialog().ok('错误', '错误001')
				sys.exit(0)
			m1 = re.findall('<tr class="js-navigation-item">\s*(.*?)\s*</tr>', content, re.DOTALL)
			for e1 in m1:
				m21 = re.search('<svg\s+.*?class="[^"]*?octicon-file-directory[^"]*?".*?>.*?</svg>', e1, re.DOTALL)
				m22 = re.search('<a\s+.*?href="([^"]*?)".*?>(.*?)</a>', e1, re.DOTALL)
				if m21 and m22:
					item(m22.group(2), 'https://github.com' + m22.group(1))
					continue
				m21 = re.search('<svg\s+.*?class="[^"]*?octicon-file[^"]*?".*?>.*?</svg>', e1, re.DOTALL)
				m22 = re.search('<a\s+.*?href="([^"]*?)".*?>(.*?)</a>', e1, re.DOTALL)
				if m21 and m22:
					item(m22.group(2), 'https://github.com' + m22.group(1))
					continue
		xbmcplugin.endOfDirectory(handle)
	else:
		play('', url)
